#ifdef WIN32
#pragma warning(disable:4996)
#endif

#include <codecvt>

#include "filesystem.hpp"


namespace fcf {

  std::string path_to_utf8str(const std::filesystem::path& a_path){
    #ifdef WIN32
      std::u16string wstr(a_path.u16string());
      return std::string((const char*)std::wstring_convert<std::codecvt_utf8_utf16<char16_t>, char16_t>().to_bytes(wstr).c_str());
    #else
    return std::string((const char*)a_path.u8string().c_str());
    #endif
  }

  std::filesystem::path utf8cstr_to_path(const char* a_str){
    std::filesystem::path path;
    std::string           part;
    size_t                i = 0;
    while(a_str[i]){
      char c = a_str[i];
      if (c == '/' || c == '\\') {
        #ifdef WIN32
          if (i != 0 && a_str[i-1]==':')
            part += '\\';
        #else
          if (i == 0)
              path.append("/");
        #endif

        if (!part.empty()) {
          #ifdef WIN32
          path.append(std::wstring_convert<std::codecvt_utf8_utf16<char16_t>, char16_t>().from_bytes(part));
          #else
          path.append(part);
          #endif
          part.clear();
        }
      } else {
        part += c;
      }
      ++i;
    }

    if (!part.empty()) {
      #ifdef WIN32
      path.append(std::wstring_convert<std::codecvt_utf8_utf16<char16_t>, char16_t>().from_bytes(part));
      #else
      path.append(part);
      #endif
    }

    return path;
  }  

}
